function newLayer() {
  if (layer > 0) {
    if (length(layerMaxFan[layer]) > 0) {
      patch[layerStarts[layer]] = "+M106 S" layerMaxFan[layer]
    } else {
      patch[layerStarts[layer]] = "+M106 S" fan
    }
  }

  layerStarts[++layer] = row
#print layer":"row
}

function qsort(A, left, right,i ,last) {
  if (left >= right)
    return
  swap(A, left, left+int((right-left+1)*rand()))
  last = left
  for (i = left+1; i <= right; i++)
    if (A[i] < A[left])
      swap(A, ++last, i)
  swap(A, left, last)
  qsort(A, left, last-1)
  qsort(A, last+1, right)
}

function swap(A, i, j, t) {
  t = A[i]; A[i] = A[j]; A[j] = t
}

function color(val)
{
  # map set up
  b_b[0] = 1; b_b[1] = 1; b_b[2] = 0; b_b[3] = 0;  # blue constant for each quadrant
  b_a[0] = 0; b_a[1] = -1; b_a[2] = 0; b_a[3] = 0; # blue linear coef

  g_b[0] = 0; g_b[1] = 1; g_b[2] = 1; g_b[3] = 1;
  g_a[0] = 1; g_a[1] = 0; g_a[2] = 0; g_a[3] = -1;

  r_b[0] = 0; r_b[1] = 0; r_b[2] = 0; r_b[3] = 1;
  r_a[0] = 0; r_a[1] = 0; r_a[2] = 1; r_a[3] = 0;

  q = int(val * 4);   # compute quadrant = {0, 1, 2, 3}
  p = 4 * val - q   # position in quadrant <0 ... 1>

  # finally, project that mess to the color using map above
  kd = "Kd "r_a[q] * p + r_b[q]" "g_a[q] * p + g_b[q]" "b_a[q] * p + b_b[q] 
  if (matReference[kd]) {
    # this material is already defined
    return matReference[kd]
  } else {
    # we dont have such material yet
    matIdx++
    matReference[kd] = matIdx

    # output material into material library
    print "newmtl Mtl"matIdx >> materialFile
    print "Ns 96.078431" >> materialFile 
    print "Ka 0.000000 0.000000 0.000000" >> materialFile
    print kd >> materialFile
    print "Ks 0.500000 0.500000 0.500000" >> materialFile
    print "Ni 1.000000" >> materialFile
    print "d 1.000000" >> materialFile
    print "illum 2" >> materialFile
    return matIdx 
  }
}

BEGIN {
  print "#Material library... " > materialFile
  print "mtllib aaa.mtl" > objectFile
  v = 1
  matIdx = 0
  layer = 0
  row = 1
  layerStarts[layer] = row
  lastExtrudedZ = 0
}

$1 == "G1" {
  for (i in vals) {
    prevVals[i] = vals[i]
  }

  for (i = 2; i <= NF; i++) {
    varName = substr($i, 1, 1)
    varValue = substr($i, 2)
    vals[varName] = varValue
  }

  for (i in vals) {
    ds[i] = vals[i] - prevVals[i]
  }

  distance = sqrt(ds["X"]^2 + ds["Y"]^2)
  if (distance > maxDistance) maxDistance = distance
  if (vals["F"] > maxFeedrate) maxFeedrate = vals["F"] 

  extruded = extruded + ds["E"]


  if (ds["E"] > 0) {
     if (vals["Z"] - lastExtrudedZ > 0)   # use the Z coordinate when we extruded last for detection of layer change - this should avoid z lifts from being triggered
       newLayer()
     lastExtrudedZ = vals["Z"]

     # extruding
     print "# layer: " layer "; row: " row "; " >> objectFile
     print "v "prevVals["X"]" "prevVals["Y"]" "vals["Z"] >> objectFile
     print "v "vals["X"]" "vals["Y"]" "vals["Z"] >> objectFile
     print "v "vals["X"]" "vals["Y"]" "vals["Z"] + 0.2 >> objectFile
     print "v "prevVals["X"]" "prevVals["Y"]" "vals["Z"] + 0.2 >> objectFile
     print "" >> objectFile

     print "usemtl Mtl"color((255-fan)/256) >> objectFile

     #print "usemtl Mtl"color(fan/7800) >> objectFile
     print "f "v" "v+1" "v+2" "v+3 >> objectFile
     v += 4
  }

}

$1 == "G92" {
  for (i = 2; i <= NF; i++) {
    varName = substr($i, 1, 1)
    varValue = substr($i, 2)
    vals[varName] = varValue
  }  
}


$1 == "M107" {
  fan = 0

  if (length(layerMaxFan[layer]) == 0)
    layerMaxFan[layer] = 0

  patch[row] = "-"$0
}

$1 == "M106" {
  fan = substr($2, 2)

  if (fan > layerMaxFan[layer])
    layerMaxFan[layer] = fan

  patch[row] = "-"$0
}


{
  row++
}

END {
  print "Maximum Distance: " maxDistance;
  print "Maximum Feedrate: " maxFeedrate
  print "Total Extruded: " extruded

#  patchFile = "p.patch"

  print "--- "FILENAME > patchFile
  print "+++ dummy" >> patchFile 

  j = 0
  for (i in patch) {
    patchSorted[j++] = int(i);
  }

  qsort(patchSorted, 0, length(patchSorted) - 1);      

  for (i=0; i<length(patchSorted); i++) {
    if (substr(patch[patchSorted[i]], 1, 1) == "+") {
      print "@@ -" patchSorted[i] ",0 +" patchSorted[i] ",1 @@" >> patchFile 
      print patch[patchSorted[i]] >> patchFile
    } else { 
      print "@@ -" patchSorted[i] ",1 +" patchSorted[i] ",0 @@" >> patchFile 
      print patch[patchSorted[i]] >> patchFile
    }
  }

}
